@*******************************************************************************
@	System tick timer
@*******************************************************************************
.set	STK,		0xE000E010	


@ register offsets
.set	STK_CTRL,	0x00		
.set	STK_LOAD,	0x04		
.set	STK_VAL,	0x08		
.set	STK_CALIB,	0x0C		

@*******************************************************************************
@	Nested vectored interrupt controller
@*******************************************************************************
.set	NVIC,		0xE000E100	


@ Software trigger interrupt register
.set	NVIC_STIR,	0xE000EF00	

@*******************************************************************************
@	System control block
@*******************************************************************************
.set	SCB,		0xE000ED00	

@ register offsets
.set	SCB_CPUID,	0x000		
.set	SCB_ICSR,	0x004		
.set	SCB_VTOR,	0x008		
.set	SCB_AIRCR,	0x00C		
.set	SCB_SCR,	0x010		
.set	SCB_CCR,	0x014		
.set	SCB_SHPR1,	0x018		
.set	SCB_SHPR2,	0x01C		
.set	SCB_SHPR3,	0x020		
.set	SCB_SHCSR,	0x024		
.set	SCB_CFSR,	0x028		
.set	SCB_MMSR,	0x028		
.set	SCB_BFSR,	0x029		
.set	SCB_UFSR,	0x02A		
.set	SCB_HFSR,	0x02C		
.set	SCB_MMFAR,	0x034		
.set	SCB_BFAR,	0x038		
.set	SCB_AFSR,	0x03C		
.set	SCB_CPACR,	0x088		
.set	SCB_FPCCR,	0x234		
.set	SCB_FPCAR,	0x238		
.set	SCB_FPDSCR,	0x23C		

.set	SCB_ACTLR,	0xE000E008	

@*******************************************************************************
@	Memory protection unit
@*******************************************************************************
.set	MPU,		0xE000ED90	

@*******************************************************************************
@	Reset and clock control
@*******************************************************************************
.set	RCC,		0x40023800	

@ register offsets
.set	RCC_CR,		0x00		
.set	RCC_PLLCFGR,	0x04		
.set	RCC_CFGR,	0x08		
.set	RCC_CIR,	0x0C		
.set	RCC_AHB1RSTR,	0x10		
.set	RCC_AHB2RSTR,	0x14		
.set	RCC_AHB3RSTR,	0x18		
.set	RCC_APB1RSTR,	0x20		
.set	RCC_APB2RSTR,	0x24		
.set	RCC_AHB1ENR,	0x30		
.set	RCC_AHB2ENR,	0x34		
.set	RCC_AHB3ENR,	0x38		
.set	RCC_APB1ENR,	0x40		
.set	RCC_APB2ENR,	0x44		
.set	RCC_AHB1LPENR,	0x50		
.set	RCC_AHB2LPENR,	0x54		
.set	RCC_AHB3LPENR,	0x58		
.set	RCC_APB1LPENR,	0x60		
.set	RCC_APB2LPENR,	0x64		
.set	RCC_BDCR,	0x70		
.set	RCC_CSR,	0x74		
.set	RCC_SSCGR,	0x80		
.set	RCC_PLLI2SCFGR,	0x84		

@*******************************************************************************
@	Power
@*******************************************************************************
.set	PWR,		0x40007000	

@ register offsets
.set	PWR_CR,		0x00		
.set	PWR_CSR,	0x04		

@*******************************************************************************
@	Independent watchdog
@*******************************************************************************
.set	IWDG,		0x40003000	

@ register offsets
.set	IWDG_KR,	0x00		
.set	IWDG_PR,	0x04		
.set	IWDG_RLR,	0x08		
.set	IWDG_SR,	0x0C		

@*******************************************************************************
@	Window watchdog
@*******************************************************************************
.set	WWDG,		0x40002C00	

@ register offsets
.set	WWDG_CR,	0x00		
.set	WWDG_CFR,	0x04		
.set	WWDG_SR,	0x08		

@*******************************************************************************
@	System configuration
@*******************************************************************************
.set	SYSCFG,		0x40013800	

@ register offsets
.set	SYSCFG_MEMRMP,	0x00		
.set	SYSCFG_PMC,	0x04		
.set	SYSCFG_EXTICR1,	0x08		
.set	SYSCFG_EXTICR2,	0x0C		
.set	SYSCFG_EXTICR3,	0x10		
.set	SYSCFG_EXTICR4,	0x14		
.set	SYSCFG_CMPCR,	0x20		

@*******************************************************************************
@	Flash interface
@*******************************************************************************
.set	FLASH,		0x40023C00	

@ register offsets
.set	FLASH_ACR,	0x00		
.set	FLASH_KEYR,	0x04		
.set	FLASH_OPTKEYR,	0x08		
.set	FLASH_SR,	0x0C		
.set	FLASH_CR,	0x10		
.set	FLASH_OPTCR,	0x14		

@*******************************************************************************
@	External interrupt/event controller
@*******************************************************************************
.set	EXTI,		0x40013C00	

@ register offsets
.set	EXTI_IMR,	0x00		
.set	EXTI_EMR,	0x04		
.set	EXTI_RTSR,	0x08		
.set	EXTI_FTSR,	0x0C		
.set	EXTI_SWIER,	0x10		
.set	EXTI_PR,	0x14		

@*******************************************************************************
@	General purpose I/O
@*******************************************************************************
.set	GPIOA,		0x40020000	
.set	GPIOB,		0x40020400	
.set	GPIOC,		0x40020800	
.set	GPIOD,		0x40020C00	
.set	GPIOE,		0x40021000	
.set	GPIOF,		0x40021400	
.set	GPIOG,		0x40021800	
.set	GPIOH,		0x40021C00	
.set	GPIOI,		0x40022000	

@ register offsets
.set	GPIO_MODER,	0x00		
.set	GPIO_OTYPER,	0x04		
.set	GPIO_OSPEEDR,	0x08		
.set	GPIO_PUPDR,	0x0C		
.set	GPIO_IDR,	0x10		
.set	GPIO_ODR,	0x14		
.set	GPIO_BSRR,	0x18		
.set	GPIO_BRSR,	0x1A		
.set	GPIO_LCKR,	0x1C		
.set	GPIO_AFRL,	0x20		
.set	GPIO_AFRH,	0x24		

@*******************************************************************************
@	Timers
@*******************************************************************************
@ Advanced timers
.set	TIM1,		0x40010000	
.set	TIM8,		0x40010400	

@ General-purpose timers
.set	TIM2,		0x40000000	
.set	TIM3,		0x40000400	
.set	TIM4,		0x40000800	
.set	TIM5,		0x40000C00	

@ Basic timers
.set	TIM6,		0x40001000	
.set	TIM7,		0x40001400	

@ General-purpose timers
.set	TIM9,		0x40014000	
.set	TIM10,		0x40014400	
.set	TIM11,		0x40014800	
.set	TIM12,		0x40001800	
.set	TIM13,		0x40001C00	
.set	TIM14,		0x40002000	

@*******************************************************************************
@	Real-time clock/backup registers
@*******************************************************************************
.set	RTCBKP,		0x40002800	

@ Backup SRAM (4K)
.set	BKPRAM,		0x40024000	


@*******************************************************************************
@	ADC1 - ADC3
@*******************************************************************************
.set	ADC,		0x40012000	

@*******************************************************************************
@	DAC
@*******************************************************************************
.set	DAC,		0x40007400	

@*******************************************************************************
@	UART / USART
@*******************************************************************************
.set	UART1,		0x40011000	
.set	UART2,		0x40004400	
.set	UART3,		0x40004800	
.set	UART4,		0x40004C00	
.set	UART5,		0x40005000	
.set	UART6,		0x40011400	

@ register offsets
.set	UART_SR,	0x00		
.set	UART_DR,	0x04		
.set	UART_BRR,	0x08		
.set	UART_CR1,	0x0C		
.set	UART_CR2,	0x10		
.set	UART_CR3,	0x14		
.set	UART_GTPR,	0x18		

@*******************************************************************************
@	I2C
@*******************************************************************************
.set	I2C1,		0x40005400	
.set	I2C2,		0x40005800	
.set	I2C3,		0x40005C00	

@ register offsets
.set	I2C_CR1,	0x00		
.set	I2C_CR2,	0x04		
.set	I2C_OAR1,	0x08		
.set	I2C_OAR2,	0x0C		
.set	I2C_DR,		0x10		
.set	I2C_SR1,	0x14		
.set	I2C_SR2,	0x18		
.set	I2C_CCR,	0x1C		
.set	I2C_TRISE,	0x20		

@*******************************************************************************
@	SPI / I2S
@*******************************************************************************
.set	SPI1,		0x40013000	
.set	SPI2,		0x40003800	
.set	SPI3,		0x40003C00	
.set	I2S2ext,	0x40003400	
.set	I2S3ext,	0x40004000	

@ register offsets
.set	SPI_CR1,	0x00		
.set	SPI_CR2,	0x04		
.set	SPI_SR,		0x08		
.set	SPI_DR,		0x0C		
.set	SPI_CRCPR,	0x10		
.set	SPI_RXCRCR,	0x14		
.set	SPI_TXCRCR,	0x18		
.set	SPI_I2SCFGR,	0x1C		
.set	SPI_I2SPR,	0x20		

@*******************************************************************************
@	CAN
@*******************************************************************************
.set	CAN1,		0x40006400	
.set	CAN2,		0x40006800	

@*******************************************************************************
@	DMA controller
@*******************************************************************************
.set	DMA1,		0x40026000	
.set	DMA2,		0x40026400	

@*******************************************************************************
@	Flexible Static Memory Controller
@*******************************************************************************
.set	FSMC,		0xA0000000 	
.set	FSMCB1,		0x60000000	
.set	FSMCB2,		0x70000000	
.set	FSMCB3,		0x80000000	
.set	FSMCB4,		0x90000000	

@*******************************************************************************
@	Secure Digital I/O
@*******************************************************************************
.set	SDIO,		0x40012C00	

@*******************************************************************************
@	Random Number Generator
@*******************************************************************************
.set	RNG,		0x50060800	

@*******************************************************************************
@	CRC Generator
@*******************************************************************************
.set	CRC,		0x40023000	

@*******************************************************************************
@	Digital Camera Interface
@*******************************************************************************
.set	DCMI,		0x50050000	

@*******************************************************************************
@	USB
@*******************************************************************************
.set	USBFS,		0x50000000	
.set	USBHS,		0x40040000	

@*******************************************************************************
@	Ethernet
@*******************************************************************************
.set	MAC1,		0x40028000
.set	MAC2,		0x40028400
.set	MAC3,		0x40028800
.set	MAC4,		0x40028C00
.set	MAC5,		0x40029000

	.list


@-------------------------------------------------------------------------------
@		Begin of code section
@-------------------------------------------------------------------------------
	.syntax	unified
	.cpu	cortex-m4
	.fpu	fpv4-sp-d16
	.thumb
.equ Ram,0x20000000
@-------------------------------------------------------------------------------
@		Vector table
@-------------------------------------------------------------------------------
	.text
	.pool
	.org	0
	.word	Ram+0x400
	.word	rstHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	0			
	.word	0			
	.word	0			
	.word	0			
	.word	defHandler + 1
	.word	defHandler + 1
	.word	0			
	.word	defHandler + 1
	.word	stkHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	0			
	.word	defHandler + 1
	.word	defHandler + 1

        .org 0x400
@===============================================================================
@		System tick interrupt handler
@===============================================================================
	.global	stkHandler
stkHandler:
	ldr	r1, = SysTicks		
	ldr	r0, [r1]		
	add	r0, r0, #1		
	str	r0, [r1]		
	bx	lr			

@===============================================================================
	.global	defHandler
defHandler:
	ldr	r3, = ExcFrame		
	mrs	r0, ipsr		
	pop	{r1}			
	stm	r3!, {r0, r1}		
	add	sp, sp, #12		
	stm	r3!, {r7 - r11}		
	pop	{r0 - r2}		
	stm	r3!, {r0 - r2}		
	add	r0, sp, #4		
	ldr	r1, [r10]		
	ldr	r2, [r11]		
	ldrh	r4, [r9]		
	stm	r3!, {r0 - r2, r4}	
	b	.			

@===============================================================================
@		Reset handler
@ The reset handler saves the reset code for later identification of the reset
@ source. 
@===============================================================================
	.global	rstHandler
rstHandler:
	sub	r4, pc, #8		
	mov	r1, #1			
	ldr	r3, = ResetSrc		
	ldr	r6, = RCC		
	ldrb	r2, [r6, #RCC_CSR + 3]	
	cbz	r2, 1f			
	lsr	r2, r2, #1		
	ldr	r3, = ResetSrc		
	str	r2, [r3]		
	mov	r2, #1			
	strb	r2, [r6, #RCC_CSR + 3]

1:	bl	initSys			
        bl debug_led
	b	warm			


	.ltorg				

@*******************************************************************************
@	Clocks
@*******************************************************************************
.set	HSECLK,	8000000			
.set	SYSCLK,	168000000		
.set	RCLK,	48000000		

@*******************************************************************************
@	PLL configuration

@ The critical PLL parameters are checked for validity.
@*******************************************************************************
@ PLL input divider PLLM (allowed range: 2 - 63)
@ PLLM must be chosen so that the PLL input frequency falls in the allowed
@ range 1 - 2 MHz
.set	PLLM, 8
.if	PLLM < 2 || PLLM > 63
.error	"PLLM out of range"
.endif

@ PLL input frequency (allowed range: 1 - 2 MHz)
.set	f_PLLin, HSECLK / PLLM
.if	f_PLLin < 1000000 || f_PLLin > 2000000
.error	"f_PLLin out of range"
.endif

@ PLL output divider DIVP (allowed values: 2, 4, 6, or 8)
@ DIVP must be chosen so that f_VCO falls in the range 192 - 432 MHz
.set	DIVP, 2
.if	DIVP != 2 && DIVP != 4 && DIVP != 6 && DIVP != 8
.error	"DIVP out of range"
.endif

@ VCO frequency (allowed range: 192 - 432 MHz)
.set	f_VCO, SYSCLK * DIVP
.if	f_VCO < 192000000 || f_VCO > 432000000
.error	"f_VCO out of range"
.endif

@ PLL multiplier PLLN (allowed range: 192 - 432)
.set	PLLN, f_VCO / f_PLLin
.if	PLLN < 192 || PLLN > 432
.error	"PLLN out of range"
.endif

@ PLL divider PLLQ for RNG clock (allowed range: 2 - 15)
.set	PLLQ, f_VCO / RCLK
.if	PLLQ < 2 || PLLQ > 15
.error	"PLLQ out of range"
.endif

.set	PLLP, (DIVP - 2) / 2		
.set	PLLSRC, 1			

@ PLL configuration word to be loaded into RCC_PLLCFGR register
.set	PLLCONF, PLLQ << 24 | PLLSRC << 22 | PLLP << 16 | PLLN << 6 | PLLM

@*******************************************************************************
@	Clock configuration for AHB, APB1 and APB2 peripherals and RTC
@*******************************************************************************
.set	HPRE, 0				
.set	HCLK, SYSCLK			
.set	PPRE1, 5			
.set	PCLK1, HCLK / 4			
.set	PPRE2, 4			
.set	PCLK2, HCLK / 2			

.set	SW,	2			

.set	LSEON, 1			
.set	RTCSEL,	1			
.set	RTCEN, 1			


@ clock configuration word to be loaded into RCC_CFGR register
.set	CLKCONF, PPRE2 << 13 | PPRE1 << 10 | HPRE << 4 | SW

@ clock configuration word to be loaded into RCC_BDCR register
.set	RTCCONF, RTCEN << 15 | RTCSEL << 8 | LSEON

@*******************************************************************************
@	Flash access control settings
@*******************************************************************************
.set	LATNCY,	5			
.set	DCEN,	1			
.set	ICEN,	1			
.set	PRFTEN,	1			

@ Flash ACR configuration word to be loaded into FLASH_ACR register
.set	ACRCONF, DCEN << 10 | ICEN <<9 | PRFTEN << 8 | LATNCY

@*******************************************************************************
@	Coprocessor access enable (FPU enable)
@*******************************************************************************
.set	CP11,	3			
.set	CP10,	3			

@ coprocessor access enable word to be loaded into SCB_CPACR register
.set	CPACEN, CP11 << 22 | CP10 << 20

@*******************************************************************************
@	System control and system tick settings
@*******************************************************************************
.set	USGFLTEN,	1		
.set	BUSFLTEN,	1		
.set	MEMFLTEN,	1		
.set	UNALIGNTRP,	1		

.set	TICKSPS,	1000		
.set	CLKSOURCE,	1		
.set	TICKINT,	1		
.set	CNTENB,		1		

.set	TICKPRI,	15		

@ systick configuration word to be loaded into STK_CTRL register
.set	STKCONF, CLKSOURCE << 2 | TICKINT << 1 | CNTENB

@ tick counter reload value to be loaded into STK_LOAD register
.set	STKRELOAD, HCLK / TICKSPS

@ system tick handler priority word to be loaded into SCB_SHPR3 register
.set	STKHDLPRI, TICKPRI << 28

@ system control configuration word to be loaded into SCB_SHCSR register
.set	SHCSRCONF,  USGFLTEN << 18 |  BUSFLTEN << 17 | MEMFLTEN << 16

@ system control configuration word to be loaded into SCB_CCSR register
.set	CCRCONF,  UNALIGNTRP << 3 

@ system reset request word to be loaded into SCB_AIRCR register
.set	SYSRESETREQ,	0x05FA0004

@*******************************************************************************
@	RAMs and peripherals enable
@*******************************************************************************
.set	CCMRAMEN,	1		
.set	BKPRAMEN,	1		
.set	GPIOBEN,	1		
.set	GPIODEN,	1		
.set	USART3EN,	1		
.set	PWREN,		1		
.set	DBP,		1		

@ AHB1 configuration word to be loaded into RCC_AHB1ENR register
.set	AHB1CONF,	CCMRAMEN << 20 | BKPRAMEN << 18 | GPIODEN << 3 | GPIOBEN << 1

@ APB1 configuration word to be loaded into RCC_APB1ENR register
.set	APB1CONF,	PWREN << 28 | USART3EN << 18

@ Power configuration word to be loaded into PWR_CR register
.set	PWRCONF,	DBP << 8

@*******************************************************************************
@	GPIOB settings
@*******************************************************************************
@ GPIO pin mode (0 = input, 1 = output, 2 = alternate function, 3 = analog)
.set	PB11MODE,	2		
.set	PB10MODE,	2		

.set	PB11AF,		7		
.set	PB10AF,		7		

@ GPIOB mode configuration word to be loaded into GPIO_MODER register
.set	GPIOBMODE,	PB11MODE << 22 | PB10MODE << 20

@ GPIOB alternate function configuration word (load into GPIO_AFRH register)
.set	GPIOBAFH,	PB11AF << 12 | PB10AF << 8

@*******************************************************************************
@	GPIOD settings
@*******************************************************************************
@ GPIO pin mode (0 = input, 1 = output, 2 = alternate function, 3 = analog)
.set	PD15MODE,	1		
.set	PD14MODE,	1		
.set	PD13MODE,	1		
.set	PD12MODE,	1		

@ GPIOD mode configuration word to be loaded into GPIO_MODER register
.set	GPIODMODE, PD15MODE << 30 | PD14MODE << 28 | PD13MODE << 26 | PD12MODE << 24

@*******************************************************************************
@	Serial port settings
@*******************************************************************************
.set	BAUDRATE,	38400		

.set	OVER8,		0		
.set	UE,		1		
.set	TE,		1		
.set	RE,		1		
.set	M,		0		
.set	PCE,		0		
.set	PS,		0		

@ UART baud rate divisor word to be loaded into UART_BRR register
.set	BRDIVISOR, PCLK1 / BAUDRATE	

@ UART configuration word to be loaded into UART_CR1 register
.set	UARTCONF, OVER8 << 15 | UE << 13 | M << 12 | PCE << 10 | PS << 9 | TE << 3 | RE << 2


@*******************************************************************************
@		System initialization
@*******************************************************************************
initSys:
	cpsid	i			
	ldr	r0, = Mstk		
	mov	sp, r0
	isb
	ldr	r6, = RCC		
	ldr	r0, [r6, #RCC_CR]
	orr	r0, r0, #0x10000	
	str	r0, [r6, #RCC_CR]

	
1:	ldr	r0, [r6, #RCC_CR]
	tst	r0, #0x20000		
	beq	1b

	
	ldr	r0, = PLLCONF		
	str	r0, [r6, #RCC_PLLCFGR]
	ldr	r0, [r6, #RCC_CR]
	orr	r0, r0, #0x1000000	
	str	r0, [r6, #RCC_CR]

	
2:	ldr	r0, [r6, #RCC_CR]
	tst	r0, #0x2000000		
	beq	2b

	
	ldr	r5, = FLASH		
	ldr	r0, = ACRCONF		
	str	r0, [r5, #FLASH_ACR]

	
3:	ldr	r1, [r5, #FLASH_ACR]	
	eor	r1, r0
	tst	r1, #0x07
	bne	3b

	
	ldr	r0, = CLKCONF		
	str	r0, [r6, #RCC_CFGR]

	
4:	ldr	r0, [r6, #RCC_CFGR]	
	tst	r0, #0x08		
	beq	4b

	
	ldr	r0, = AHB1CONF		
	str	r0, [r6, #RCC_AHB1ENR]	
	ldr	r0, = APB1CONF		
	str	r0, [r6, #RCC_APB1ENR]

	
	ldr	r5, = PWR		
	ldr	r0, = PWRCONF		
	str	r0, [r5, #PWR_CR]

	
	ldr	r0, = RTCCONF		
	str	r0, [r6, #RCC_BDCR]	

	
5:	ldr	r0, [r6, #RCC_BDCR]
	tst	r0, #0x02		
	ldr	r6, = SCB		
	ldr	r0, = SHCSRCONF		
	str	r0, [r6, #SCB_SHCSR]

	
	ldr	r0, = CPACEN		
	str	r0, [r6, #SCB_CPACR] 	
	dsb				
	isb				

	
	ldr	r0, = STKHDLPRI		
	str	r0, [r6, #SCB_SHPR3]

	
	ldr	r6, = STK		
	ldr	r1, = SysTicks		
	mov	r0, #0
	str	r0, [r1]		
	str	r0, [r6, #STK_VAL]	
	ldr	r0, = STKRELOAD		
	str	r0, [r6, #STK_LOAD]
	ldr	r0, = STKCONF		
	str	r0, [r6, #STK_CTRL]	

	bx	lr			

	.ltorg				

	.global debug_led

debug_led:
	push {r0,r1}
	ldr r1, = GPIOE + GPIO_MODER
	ldr r0, = 0x01      
	str r0,[r1]

	ldr r1,= GPIOE + GPIO_OTYPER  
	ldr r0, = 0x01           
	str r0,[r1]

	ldr r1,= GPIOE + GPIO_ODR     
	ldr r0, = 0x0
	str r0,[r1]
 	pop {r0,r1}
	bx lr
	.global	warm
warm:
	ldr	r10, = Dstk		
	ldr	r11, = Rstk		
	ldr	r7, = foreground	
	str	r7, [r7]		
	ldr	r9, boot		
	b warm 
		.align
		.global	params, ptokens, pnames0, pnames, pnumnames
		.global	prtokens, prnames0, pfreeram, pfreeflash
		.global boot 
params:
ptokens:	.word	0		
pnames0:	.word	1		
pnames:		.word	2		
					
pnumnames:	.word	3		
					
prtokens:	.word	4		
prnames0:	.word	5		
pfreeram:	.word	6		
pfreeflash:	.word	7		
boot:		.word	8		

@-------------------------------------------------------------------------------
		.global	prim_cutoff, endOfDictionary
prim_cutoff:
endOfDictionary:

@-------------------------------------------------------------------------------
@	Main stack and system variables (CCM RAM)
@-------------------------------------------------------------------------------
		.bss
		.global	MstkLimit, Mstk
MstkLimit:	.space	256 * 4		
Mstk:
		.global	SysTicks, ResetSrc, TimeSlice, ExcFrame
SysTicks:	.space	4		
ResetSrc:	.space	4		
TimeSlice:	.space	4		

ExcFrame:	.space	14 * 4		

@-------------------------------------------------------------------------------
@	Foreground task (TERMINAL task) TSA, pads and stacks
@-------------------------------------------------------------------------------
		.global	foreground, pad, pad2
.set TSAlen,44

foreground:	.space	TSAlen		
pad:		.space	64		
pad2:		.space	132		

		.align
		.global	DstkLimit, Dstk
DstkLimit:	.space	256 * 4		
Dstk:
		.global	RstkLimit, Rstk
RstkLimit:	.space	256 * 4		
Rstk:

		.align

@-------------------------------------------------------------------------------
@	Free CCM RAM space
@-------------------------------------------------------------------------------
		.global	freeRAM
freeRAM:
	.end
